<template>
  <PageContainer>
    <template slot="header">
      <MControlPanel
        :state="pageState"
        :can-create="canCreate"
        :can-update="canUpdate"
        @on-state-button-clicked="onStateButtonClicked()"
        @on-action-button-clicked="onActionButtonClicked()"
        :actions="actions"
      >
      </MControlPanel>
    </template>

    <template slot="content" style="background-color: white">
      <div class="row justify-left" style="background-color: white; ">
        <div class="col-12 q-pb-xs q-pt-xs q-pl-md  q-mt-xs q-mb-xs">
          <ValidationObserver v-slot="{ handleSubmit }">
            <q-form ref="FormSubmit" @submit="handleSubmit(onSubmit)">
              <q-card flat square class="row q-pa-md q-ma-sm scroll">
                <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                  <MField
                    label="Code"
                    v-model="form.slug"
                    :main-design="pageState === 'view'  ? 'borderless' : 'outlined'"
                    :readonly="pageState === 'view'"
                    :hide-bottom-space="pageState === 'view' "
                    validation-rules="required"
                    orientation="vertical"
                    @m-keyup-enter="onFormSubmit"
                  />
                </div>
                <div class="col-xs-12 col-sm-12 col-md-6 col-lg-6">
                  <MField
                    label="Nom"
                    v-model="form.name"
                    :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                    :readonly="pageState ==='view'"
                    :hide-bottom-space="pageState ==='view' "
                    validation-rules="required"
                    orientation="vertical"
                    @m-keyup-enter="onFormSubmit"
                  />
                </div>
                <div class="col-xs-12 col-sm-12 col-md-12 col-lg-12">
                  <MField
                    label="Description"
                    v-model="form.description"
                    :main-design="pageState ==='view'  ? 'borderless' : 'outlined'"
                    :readonly="pageState ==='view'"
                    :hide-bottom-space="pageState ==='view'"
                    type-input="textarea"
                    orientation="vertical" autogrow
                    type="textarea" @m-keyup-enter="onFormSubmit"
                  />
                </div>
              </q-card>
            </q-form>
          </ValidationObserver>
          <q-tabs
            v-model="tab" active-color="primary"
            align="left"
            class="text-grey" dense
            indicator-color="primary"
            narrow-indicator
          >
            <q-tab label="Permissions" name="permissions" no-caps/>
          </q-tabs>
          <q-tab-panels v-model="tab" animated>
            <q-tab-panel name="permissions">
              <div class="row">
                <div v-if="pageState === 'update'" class="col-12 q-mt-lg q-pb-md">
                  <q-btn
                    class="float-right q-px-sm"
                    color="primary"
                    dense label="Enrégistrer"
                    stretch
                    @click="onSavePermissions"
                  />
                </div>
                <div class="col-12">
                  <q-double-draggable
                    :base-list.sync="permissions"
                    :target-list.sync="form.permissions"
                    label-attr="description"
                    name-attr="id"
                    base-title="Toutes les permissions"
                    target-title="Permissions du rôle"
                  >
                  </q-double-draggable>
                </div>
              </div>
            </q-tab-panel>
          </q-tab-panels>
        </div>
      </div>
    </template>
  </PageContainer>
</template>

<script>
import PageContainer from "components/PageContainer";
import MControlPanel from "components/MControlPanel";
import {mapActions, mapState} from 'vuex'
import MField from "components/forms/MField";
import MSelect from "components/forms/MSelect";
import MTable from "components/datatables/MTable";
import {ValidationObserver} from 'vee-validate';
import QDoubleDraggable from "components/datatables/QDoubleDraggable";

export default {
  name: "RolesForm",
  components: {QDoubleDraggable, PageContainer, MControlPanel, MField, MSelect, MTable, ValidationObserver},

  async preFetch({store, currentRoute}) {
    let id = currentRoute.query.id || currentRoute.params.id
    if (id) return await store.dispatch('roles/show', {id});
  },

  data() {
    return {
      loading: false,
      form: {},
      avatar: null,
      showPassword: false,
      tab: 'permissions',
      permissions: []
    }
  },

  methods: {
    onSubmit() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment effectuer cette action ?',
        cancel: true,
        persistent: false,
      }).onOk(() => {
        let payload = this.getPayload()
        this.Loader.show()
        let promise = payload.id ? this.update(payload) : this.create(payload);
        let msg = payload.id ? 'Mise à jour!' : 'Création réussie';
        promise.then(async res => {
          await this.$store.dispatch('roles/show', {id: res.id}).then(async () => {
            await this.Motify('success', msg, {path: `${this.baseUrl}/form/view`, query: {id: res.id}})
            this.form = _.clone(this.currentItem)
          }).catch((err) => {
            this.Motify('error', this._getErrorMessage(err))
          })
        }).catch(err => {
          this.Motify('error', this._getErrorMessage(err), null, 5000)
        }).finally(() => {
          this.Loader.hide()
        })
      })
    },

    onSavePermissions() {
      this.$q.dialog({
        title: 'Confirmer',
        message: 'Voulez-vous vraiment enrégistrer ces permissions ?',
        cancel: true,
        persistent: true
      }).onOk(async () => {
        if (this.form.id) {
          const permissions = this.form.permissions.map(x => x.id)
          await this.$store.dispatch('roles/attachPermissions', {
            id: this.form.id,
            permissions: permissions
          }).then(async (res) => {
            await this.$store.dispatch('roles/show', {id: this.form.id}).then(async () => {
              await this.Motify('success', `Permissions mise à jour pour le rôle ${this.form.name}`,
                {path: `${this.baseUrl}/form/view`, query: {id: this.form.id}}, 2000)
              this.form = _.clone(this.currentItem)
            }).catch((err) => {
              this.Motify('error', this._getErrorMessage(err))
            })
          }).catch(err => {
            this.Motify('error', this._getErrorMessage(err))
          })
        }
      })
    },

    mapPayload() {
      if (this.pageState === 'create') {
        this.resetForm()
      } else if (this.pageState === 'update' || this.pageState === 'view') {
        this.form = _.clone(this.currentItem)
      }
    },

    getPayload() {
      return _.clone(this.form)
    },

    resetForm() {
      this.form = _.clone(this.mForm)
    },

    onDuplicate() {
      this.$q.dialog({
        parent: this,
        message: 'Voulez-vous vraiment dupliquer cet enregistrement?',
        cancel: true,
      }).onOk(() => {
        this.form = _.clone(this.currentItem)
        this.form.id = null
        return this.$router.replace({path: `${this.baseUrl}/form/create`})
      })
    },

    onFormSubmit() {
      !this.$refs.FormSubmit.submit()
    },

    onStateButtonClicked() {
      if (this.pageState === 'view') {
        return this.$router.replace({
          path: `${this.baseUrl}/form/update`,
          query: {id: this.$route.query.id},
        })
      } else {
        this.onFormSubmit()
      }
    },

    onActionButtonClicked() {
      if (this.pageState === 'update') {
        this.$router.push({
          path: `${this.baseUrl}/form/view`,
          query: {id: this.$route.query.id},
        })
      } else if (this.pageState === 'create') {
        this.$router.push({path: `${this.baseUrl}`,})
      } else if (this.pageState === 'view') {
        this.resetForm()
        this.$router.push({
          path: `${this.baseUrl}/form/create`,
        })
      }
    },

    async preFetchList() {
      await Promise.all([
        this.$store.dispatch('permissions/index').then(() => {
          this.permissions = _.differenceBy(this.permissionsList, _.get(this.form, 'permissions', []) ,'id')
        })
      ])
    },


    ...mapActions({
      create: 'roles/create',
      update: 'roles/update',
    }),
  },

  computed: {
    pageState() {
      return this.$route.params.type || this.$route.query.type
    },
    canCreate() {
      return true
    },
    canUpdate() {
      return true
    },
    actions() {
      return [
        {
          label: 'Dupliquer',
          func: this.onDuplicate,
          display: (this.pageState !== 'create' && this.form)
        },
      ]
    },

    ...mapState({
      permissionsList: state => _.get(state, 'permissions.items.data', []) || [],
      currentItem: state => state.roles.item,
      baseUrl: state => state.roles.baseUrl,
      mForm: state => state.roles.form,
    })
  },

  async mounted() {
    this.mapPayload()
    await this.preFetchList()
  },
}
</script>

<style scoped>

</style>
